﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="OptimizelyExperimentPlugin.aspx.cs" Inherits="Oshyn.Episerver.Addons.EpiserverOptimizelyPlus.Plugins.OptimizelyExperimentPlugin" %>


<asp:Content runat="server" ContentPlaceHolderID="FullRegion">

  <link rel="stylesheet" href="/Static/Optimizely/css/jquery-ui.css">
  <script src="/Static/Optimizely/js/jquery.min.js"></script>
  <script src="/Static/Optimizely/js/jquery-ui.js"></script>
  <script src="/Static/Optimizely/js/optimizely.js"></script>
    
    <script type="text/javascript">

        $(document).ready(function () {
			
			$(".epi-tabView-navigation li:first-child").click(function() {
			  $('#block_selector').prop( "disabled", true );
			});
			
            $.ajax({
                type: 'GET',
                url: '/OptimizelyIntegration/GetListAllProjects',
                contentType: 'text/plain',
                dataType: 'json',
                xhr: function () {
                    var xhr = jQuery.ajaxSettings.xhr();
                    var setRequestHeader = xhr.setRequestHeader;
                    xhr.setRequestHeader = function (name, value) {
                        if (name == 'X-Requested-With') return;
                        setRequestHeader.call(this, name, value);
                    }
                    return xhr;
                },
                success: function (data) {
					if (data.ProjectName !=""){
						$('#project_selector').empty();
						$.each(data, function (i, d) {                        
							$('#project_selector').removeAttr("disabled");
							$('#project_selector').append('<option value="' + d.ProjectId + '">' + d.ProjectName + '</option>');
						});				
					}
					if((data.success == false) || (data.length == 0)){
						$('#FullRegion_GeneralTable').hide();
						showDialog('Information', 'No Projects Found');
					}
					if((data.success == false) && (data.errorLicence == true)){
						$('#FullRegion_GeneralTable').hide();
						//showDialog('Error', data.error);
						$('#dialog').dialog("close");
						showDialogWithButtons2(
							'Error',
							data.error,
							function () {
								window.open(data.url);
							},
							function () {
								$(this).dialog("close");
							},
							data.buttonName
						);
					}

                },

                error: function () {
                    $('#project_selector').attr("disabled");
                }
            });

            $("#dialog").dialog({
                autoOpen: false
            });

            $("#dialogWithButtons").dialog({
                autoOpen: false,
                /*buttons: {
                    'Ok': function (e) {
                        console.log('Ok here!!!');
                    },
                    'Cancel': function (e) {
                        console.log('Cancel here!!!');
                    }
                }*/
            });

            $.ajax({
                type: 'GET',
                url: '/OptimizelyIntegration/GetListVisitorGroups',
                contentType: 'text/plain',
                dataType: 'json',
                xhr: function () {
                    var xhr = jQuery.ajaxSettings.xhr();
                    var setRequestHeader = xhr.setRequestHeader;
                    xhr.setRequestHeader = function (name, value) {
                        if (name == 'X-Requested-With') return;
                        setRequestHeader.call(this, name, value);
                    }
                    return xhr;
                },
                success: function (data) {
                    if (data.length > 0) {
                        $('#audiences_selector').empty();
                        $.each(data, function (i, d) {
                            $('#audiences_selector').removeAttr("disabled");
                            $('#audiences_selector').append('<option value="' + d.Id + '">' + d.Name + '</option>');
                        });
                    } else {
                        $('#audiences_selector').empty();
                        $('#audiences_selector').attr("disabled");
                        $('#audiences_selector').append('<option>No audiences to display</option>');
                    }
                },

                error: function () {
                    $('#project_selector').attr("disabled");
                }
            });            

            //var tmpFunc = new Function("getCookie");
            //tmpFunc("EPi_NumberOfVisits");

            //console.log('over here!!!');
            //console.log(tmpFunc("EPi_NumberOfVisits"));
            //var test = window["getCookie"]("EPi_NumberOfVisits");
            //console.log(test);

            //var st = "26042013";
            //console.log(parseDate(st));

           // var date1 = new Date("7/13/2010");
            //var date2 = new Date("12/15/2010");
            //console.log(getDateDifferenceDays(date1, date2));
            //console.log(getDateDifference(date1, date2));

            //console.log(generateAudienceforNumberOfVisits('Equal', 8, 'Total', -1, '', ''));

            //console.log(generateAudienceforNumberOfVisitsServer('32e2881a-10f9-45ff-b076-d63c92c3c022'));

            /*
            var resultado = generateAudienceforNumberOfVisitsServer('f000d250-e440-4297-801b-8cbd26ab1a16');
            
            if (resultado) {
                console.log(resultado);
            } else {
                console.log(resultado);
            }
            */

        });


        function selectPageReference(displayTextboxId, valueTextboxId) {
            var dialogUrl = '<%= EPiServer.UriSupport.ResolveUrlFromUIBySettings("edit/pagebrowser.aspx") %>';

            var callbackArguments = new Object();
            callbackArguments.value = valueTextboxId;
            var features = { width: 600, height: 510 };
            var linkAttributes = new Object();
            var dialogArguments = linkAttributes;

            var callbackMethod = function (returnValue, callbackArgs) {
                if (returnValue != undefined) {
                    var textBox = document.getElementById(callbackArgs.value);

                    $.ajax({
                        type: 'GET',
                        url: '/OptimizelyIntegration/GetBlockListByPage',
                        contentType: 'text/plain',
                        dataType: 'json',
                        data: { 'pageReferenceId': textBox.value },
                        xhr: function () {
                            // Get new xhr object using default factory
                            var xhr = jQuery.ajaxSettings.xhr();
                            // Copy the browser's native setRequestHeader method
                            var setRequestHeader = xhr.setRequestHeader;
                            // Replace with a wrapper
                            xhr.setRequestHeader = function (name, value) {
                                // Ignore the X-Requested-With header
                                if (name == 'X-Requested-With') return;
                                // Otherwise call the native setRequestHeader method
                                // Note: setRequestHeader requires its 'this' to be the xhr object,
                                // which is what 'this' is here when executed.
                                setRequestHeader.call(this, name, value);
                            }
                            // pass it on to jQuery
                            return xhr;
                        },

                        success: function (data) {
                            console.log(data.length);

                            if (data.length > 0) {
                                $('#block_selector').empty();
                                $.each(data, function (i, d) {
                                    $('#block_selector').removeAttr("disabled");
                                    $('#block_selector').append('<option value="' + d.Id + '">' + d.Name + '</option>');
                                });
                            } else {
                                $('#block_selector').empty();
                                $('#block_selector').attr("disabled");
                                $('#block_selector').append('<option>Select a page first</option>');
								if($('#FullRegion_actionTab_Tab1').hasClass('epi-tabView-navigation-item-selected')){
								  showDialog('Information', 'Please, create the Optimizely block first');
								}
								if (data.success == false) {
									showDialog('Information', 'Sorry there was an error, please check your data');
								}
                                
                            }

                        },

                        error: function () {
                            console.log('error');
                            $('#block_selector').attr("disabled");
                        }
                    });

                }
                else
                    Clear(callbackArgs.value);
            };
            EPi.CreatePageBrowserDialog(dialogUrl, document.getElementById(valueTextboxId).value, 'False', 'False', displayTextboxId, valueTextboxId, 'en', callbackMethod, callbackArguments, false);
        }

    

</script>

<style>
.epi-formArea h2{
    font-family: Verdana,Arial,Helvetica,sans-serif;
    color: #131313;
    font-size: 14px;
    margin-bottom: 10px;
}
.ui-dialog .ui-dialog-buttonpane .ui-dialog-buttonset {
    float: none!important;
    text-align: center;
}
.ui-dialog .ui-dialog-buttonpane button {
    text-transform: uppercase;
}
#dialogWithButtonsMessage{
     text-align: center;   
}
</style>
    <div class="epi-formArea epi-padding" >

                <div id="dialog" title="Basic dialog">
                  <h2 id="dialogMessage"></h2>
                </div>

                <div id="dialogWithButtons" title="Basic dialog">
                  <h2 id="dialogWithButtonsMessage"></h2>
                </div>

                <div class="epi-formArea" ID="GeneralTable" runat="server">
                    <div class="epi-size25">

                        <div>
                            <label for="project_selector" style="width: 10em;">Switch project</label>
                            <select id="project_selector" style="border-radius: 4px;min-width: 200px;" disabled>  
                            </select>
                        </div>

                         <EPiServerUI:TabStrip  runat="server" id="actionTab" EnableViewState="true" GeneratesPostBack="False" targetid="tabView" supportedpluginarea="SystemSettings">
                            <EPiServerUI:Tab Text="Experiments" runat="server" ID="Tab1" />
                            <EPiServerUI:Tab Text="Audiences"  runat="server" ID="Tab2" />
							<EPiServerUI:Tab Text="Custom Events"  runat="server" ID="Tab3" />
                        </EPiServerUI:TabStrip>

                        <!-- <h2 style="margin-top: 20px;">Create Experiment</h2> -->


                        <asp:Panel runat="server" ID="tabView" CssClass="epi-padding">
                            <asp:Panel CssClass="epi-formArea epi-paddingHorizontal" ID="Panel2" runat="server">

                                <div class="epi-formArea experiments" ID="Div1" runat="server">
									<h2>Create Experiment</h2>
                                    <div style="margin: 0.5em 0;">
                                            <label for="experimentName" style="width: 10em;">Name</label>
                                            <input type="text" id="experimentName" style="border-radius: 4px;padding: 1px;min-width: 200px;" />
                                    </div>
                        
                                    <div style="margin: 0.5em 0;">
                                            <label for="page-selector_Display" style="width: 10em;">Select a page</label>
                                            <input type="hidden" id="page-selector_Value" name="page-selector_Value" />
                                            <input type="text" id="page-selector_Display" style="border-radius: 4px;padding: 1px;min-width: 200px;" name="page-selector_Display" disabled="disabled" />
                                            <input id="page-selector-button" name="page-selector-button" class="epismallbutton" type="button" onclick="selectPageReference('page-selector_Display', 'page-selector_Value')" value="..." />
                                    </div>

                                    <div style="margin: 0.5em 0;">
                                            <label for="block_selector" style="width: 10em;">Select a block</label>
                                            <select id="block_selector" style="border-radius: 4px;min-width: 200px;" disabled>
                                                <option>Select a page first</option>   
                                            </select>
                                    </div>


                                    <episerverui:toolbutton id="Toolbutton2" 
                                        runat="server" 
                                        text="<%$ Resources: EPiServer, button.save %>" 
                                        tooltip="<%$ Resources: EPiServer, button.save %>" 
                                        skinid="Save" 
                                        OnClientClick="saveExperiment();return false;"
                                        />
                                </div> 
                            </asp:Panel>

                            <asp:Panel CssClass="epi-formArea epi-paddingHorizontal" ID="publishWinner" runat="server">
                                <div class="epi-formArea" ID="Div2" runat="server">
								<h2>Export Audience</h2>
                                    <div class="epi-size25">

                        
                                        <div style="margin: 0.5em 0;">
                                            <label style="width: 10em;">Audiences </label> 
                                             <select id="audiences_selector" style="border-radius: 4px;min-width: 200px;" disabled>
                                                <option value="0" disabled>No audiences to display</option>
                                            </select>
                                        </div>


                                        <episerverui:toolbutton id="Toolbutton3" 
                                            runat="server" 
                                            text="<%$ Resources: EPiServer, button.export %>" 
                                            tooltip="<%$ Resources: EPiServer, button.export %>" 
                                            skinid="SavePublish"
                                            OnClientClick="exportAudiences();return false;" />
                                    </div>
                                </div> 
                            </asp:Panel>
							
						<asp:Panel CssClass="epi-formArea epi-paddingHorizontal" ID="sce" runat="server">
                                <div class="epi-formArea" ID="Div3" runat="server">
									<h2>Setup Custom Event</h2>
                                    <div class="epi-size25">

                        
                                    <div style="margin: 0.5em 0;">
                                            <label for="page-selector_Display" style="width: 10em;">Select a page</label>
                                            <input type="hidden" id="page-selector_Value2" name="page-selector_Value2" />
                                            <input type="text" id="page-selector_Display2" style="border-radius: 4px;padding: 1px;min-width: 200px;" name="page-selector_Display2" disabled="disabled" />
                                            <input id="page-selector-button2" name="page-selector-button2" class="epismallbutton" type="button" onclick="selectPageReference('page-selector_Display2', 'page-selector_Value2')" value="..." />
                                    </div>
										<div style="margin: 0.5em 0;">
                                            <label for="code" style="width: 10em;">Code</label>
											<textarea rows="2" cols="24" id="code"></textarea>
										</div>

										
                                    <episerverui:toolbutton id="Toolbutton4" 
                                        runat="server" 
                                        text="<%$ Resources: EPiServer, button.save %>" 
                                        tooltip="<%$ Resources: EPiServer, button.save %>" 
                                        skinid="Save" 
                                        OnClientClick="saveCustomEvent();return false;"
                                        />

                                    </div>
                                </div> 
                        </asp:Panel>

                        </asp:Panel>

                    </div>
                </div> 


       
        </div>
    </asp:Content>