﻿function saveCustomEvent() {
	var pageValue = document.getElementById('page-selector_Value2').value;
	var code = $('#code').val();
	if (pageValue.length > 0) {
	        $.ajax({
            type: 'POST',
            url: '/OptimizelyIntegration/SaveSetupCustomEvent',
            dataType: 'json',
            data: {
                pageReferenceId: pageValue,
                code: code
            },
            xhr: function () {
                var xhr = jQuery.ajaxSettings.xhr();
                var setRequestHeader = xhr.setRequestHeader;
                xhr.setRequestHeader = function (name, value) {
                    if (name == 'X-Requested-With') return;
                    setRequestHeader.call(this, name, value);
                }
                return xhr;
            },
            success: function (data) {
                $('#page-selector_Display2').val('');
				$('#page-selector_Value2').val('');
                $('#code').val('');
				showDialog('Information', 'Custom Event Saved');
				setTimeout(function(){
					$(".ui-dialog-titlebar-close").click();
				},5000)
                if (data.error) {
                    showDialog('Server Error', 'Sorry there was an error, please check your data');
                } else {
/*                     var experimentId = data.idExperiment;
                    var win = window.open("https://app.optimizely.com/v2/projects/" + projectId + "/experiments/" + experimentId, '_blank');
                    if (win) {
                        //Browser has allowed it to be opened
                        win.focus();
                    } else {
                        //Browser has blocked it
                        alert('Please allow popups for this website');
                    } */
                }
                //window.location.replace("https://app.optimizely.com/v2/projects/8185995669/experiments/8198416215");



                //loginTo3PL('https://app.optimizely.com/signin', 'mariela.pancho@siteport.net', 'sorpresa1979');
            },

            error: function () {
                console.log('error');
                //return false;
            }
        });	
	}
	else{
		showDialog('Error', 'Sorry there was an error, please check your data');
	}
}
function saveExperiment() {
    var projectId = document.getElementById('project_selector').value;
    var pageValue = document.getElementById('page-selector_Value').value;
    var blockValue = document.getElementById('block_selector').value;
    var experimentName = document.getElementById('experimentName').value;
    var flag = 0;

    if (projectId.length > 0 && pageValue.length > 0 && (blockValue.length > 0 && blockValue != "Select a page first") && experimentName.length > 0) {
        $.ajax({
            type: 'POST',
            url: '/OptimizelyIntegration/SaveExperiment',
            //contentType: 'text/plain',
            /*headers: {
                'X-Requested-With': 'XMLHttpRequest',
                'Content-Type': 'application/x-www-form-urlencoded'
            },*/
            dataType: 'json',
            data: {
                projectId: projectId,
                pageReferenceId: pageValue,
                blockReferenceId: blockValue,
                experimentName: experimentName,
                flag: flag
            },
            xhr: function () {
                var xhr = jQuery.ajaxSettings.xhr();
                var setRequestHeader = xhr.setRequestHeader;
                xhr.setRequestHeader = function (name, value) {
                    if (name == 'X-Requested-With') return;
                    setRequestHeader.call(this, name, value);
                }
                return xhr;
            },
            success: function (data) {
                document.getElementById('page-selector_Value').value = "";
                document.getElementById('page-selector_Display').value = "";
                document.getElementById('experimentName').value = "";
                $('#block_selector').empty();
                $('#block_selector').attr("disabled");

                if (data.error) {
                    showDialog('Server Error', 'Sorry there was an error, please check your data');
                } else {
                    var experimentId = data.idExperiment;
                    var win = window.open("https://app.optimizely.com/v2/projects/" + projectId + "/experiments/" + experimentId, '_blank');
                    if (win) {
                        //Browser has allowed it to be opened
                        win.focus();
                    } else {
                        //Browser has blocked it
                        alert('Please allow popups for this website');
                    }
                }
                //window.location.replace("https://app.optimizely.com/v2/projects/8185995669/experiments/8198416215");



                //loginTo3PL('https://app.optimizely.com/signin', 'mariela.pancho@siteport.net', 'sorpresa1979');
            },

            error: function () {
                console.log('error');
                //return false;
            }
        });
    } else {
        showDialog('Error', 'Sorry there was an error, please check your data');
    }


}

function exportAudiences() {
    var projectId = document.getElementById('project_selector').value;
    var audienceValue = document.getElementById('audiences_selector').value;

    var e = document.getElementById("audiences_selector");
    var value = e.options[e.selectedIndex].value;
    var text = e.options[e.selectedIndex].text;

    if (projectId.length > 0 && audienceValue.length > 0) {
        console.log(value);
        console.log(text);

        var handleResponseOK = function (data) {
            console.log('done');
            console.log(data);
        }

        var handleResponseCancel = function (data) {
            console.log('cancel');
            console.log(data);
        }

        var handleFail = function (data) {
            console.log('something goes wrong with the server');
            console.log(data);
        }

        var saveAudienceRequest = function (projectId, audienceValue, result, audienceId) {
            var request = $.ajax({
                type: 'POST',
                url: '/OptimizelyIntegration/SaveAudience',
                dataType: 'json',
                data: {
                    projectId: projectId,
                    visitorGroupId: audienceValue,
                    result: result,
                    audienceId: audienceId
                },
                xhr: function () {
                    var xhr = jQuery.ajaxSettings.xhr();
                    var setRequestHeader = xhr.setRequestHeader;
                    xhr.setRequestHeader = function (name, value) {
                        if (name == 'X-Requested-With') return;
                        setRequestHeader.call(this, name, value);
                    }
                    return xhr;
                }
            });

            request.done(function (data) {
				console.log('data',data);
                if (data == true) {
                    showDialog('Info', 'Audience exported correctly');
					setTimeout(function(){
						$(".ui-dialog-titlebar-close").click();
					},5000)
                } else {
                    showDialog('Error', 'Sorry there was an error, please check your data');
                }
            });

            request.fail(function (data) {
                console.log('error');
                showDialog('Error', 'Sorry there was an error in the server');
            });

        }

        var checkNameAudienceRequest = function (projectId, audienceValue, nameAudience) {
            var request = $.ajax({
                type: 'POST',
                url: '/OptimizelyIntegration/CheckNameAudience',
                dataType: 'json',
                data: {
                    projectId: projectId,
                    nameAudience: nameAudience
                    //nameAudience: 'testing'
                },
                xhr: function () {
                    var xhr = jQuery.ajaxSettings.xhr();
                    var setRequestHeader = xhr.setRequestHeader;
                    xhr.setRequestHeader = function (name, value) {
                        if (name == 'X-Requested-With') return;
                        setRequestHeader.call(this, name, value);
                    }
                    return xhr;
                }
            });

            request.done(function (data) {
                if(data == -1){
                    saveAudienceRequest(projectId, audienceValue, 0, data);
                } else {
                    showDialogWithButtons(
                        'Confirm',
                        'There is already an audience with this name in Optimizely. Do you want to override it?',
                        function () {
                            //checkNameAudienceRequest.done(handleResponseOK);
                            //checkNameAudienceRequest.fail(handleFail);
                            saveAudienceRequest(projectId, audienceValue, 1, data);
                            $(this).dialog("close");
                        },
                        function () {
                            //checkNameAudienceRequest.done(handleResponseCancel);
                            saveAudienceRequest(projectId, audienceValue, 0, data);
                            $(this).dialog("close");
                    });
                }
            });

            request.fail(function (data) {
                console.log('error');
                console.log(data);
            });
        }

        checkNameAudienceRequest(projectId, audienceValue, text);

    } else {
        showDialog('Error', 'Sorry there was an error, please check your data');
    }


}

function showDialog(title, message) {
    $("#dialogMessage").html(message)
    $("#dialog").dialog("option", "title", title);
    $("#dialog").dialog("open");
}

function showDialogWithButtons(title, message, callbackOk, callbackCancel) {

    $("#dialogWithButtons").dialog("option", "buttons",
      [
        {
            text: "Yes",
            /*icons: {
                primary: "ui-icon-heart"
            },*/
            click: callbackOk
        },
        {
            text: "No",
            click: callbackCancel
        }
      ]
    );

    $("#dialogWithButtonsMessage").html(message)
    $("#dialogWithButtons").dialog("option", "title", title);
    $("#dialogWithButtons").dialog("open");
}

	function showDialogWithButtons2(title, message, callbackOk, callbackCancel, btn) {

    $("#dialogWithButtons").dialog("option", "buttons",
      [
        {
            text: btn,
            click: callbackOk
        }
      ]
    );

    $("#dialogWithButtonsMessage").html(message)
    $("#dialogWithButtons").dialog("option", "title", title);
    $("#dialogWithButtons").dialog("open");
}